package com.bsoft.aggr.task;

package ..deTemp.1734337641124;

import com.bsoft.aggr.mapper.LabreportindexMapper;
import com.bsoft.aggr.pojo.PIXDto.PatientPIXDto;
import com.bsoft.aggr.pojo.PIXDto.PatientRegistryWrapper;
import com.bsoft.aggr.pojo.PIXDto.RegistrationEventDto;
import com.bsoft.aggr.saop.SaopFormat;
import com.bsoft.aggr.saop.SharePlatformIDUtil;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class UploadSchedule {
  public static Logger logger = LoggerFactory.getLogger(com.bsoft.aggr.task.UploadSchedule.class);
  
  @Resource
  private LabreportindexMapper labreportindexMapper;
  
  @Scheduled(cron = "0 0 1 * * ?")
  public void handle() throws Exception {
    List<Map<String, Object>> mapsPho = this.labreportindexMapper.queruPhoPatientSchedule();
    if (mapsPho != null || mapsPho.size() != 0)
      for (int i = 0; i < mapsPho.size(); i++) {
        Map<String, Object> map = mapsPho.get(i);
        int a = i + 1;
        logger.info("第" + a + "条注册数据：" + map);
        Date now = new Date();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
        String creationTime = dateFormat.format(now);
        String operate = "PRPA_IN201301UV02";
        String patientSex = (new StringBuilder()).append(map.get("patientSex")).append("").toString();
        String patientName = (new StringBuilder()).append(map.get("patientName")).append("").toString();
        String patientEName = (new StringBuilder()).append(map.get("patientEnName")).append("").toString();
        String IDcard = (new StringBuilder()).append(map.get("IDcard")).append("").toString();
        String birthday = (new StringBuilder()).append(map.get("birthday")).append("").toString();
        String OrgName = "浙江省妇幼和生殖保健中心";
        String address = "杭州市万塘路256号";
        String telephone = "0571－88933603";
        String rootId = "1.2.860.330000.02.08";
        String pid = (new StringBuilder()).append(map.get("patientVisitID")).append("").toString();
        map.put("pid", pid);
        map.put("rootId", rootId);
        PatientPIXDto pix = new PatientPIXDto();
        pix.setPid(pid);
        pix.setPatientSex(patientSex);
        pix.setRootId(rootId);
        pix.setPatientName(patientName);
        pix.setPatientEName(patientEName);
        pix.setOrgName(OrgName);
        pix.setIDcard(IDcard);
        pix.setBirthday(birthday);
        pix.setAddress(address);
        pix.setTelephone(telephone);
        RegistrationEventDto dto = new RegistrationEventDto(pix);
        PatientRegistryWrapper Wrapper = new PatientRegistryWrapper(creationTime, operate, dto);
        String xml = Wrapper.getPRPA_IN201301UV02Full();
        logger.info("信息注册---PIX服务-----");
        Map<String, Object> soapWrapperPix = SharePlatformIDUtil.getSOAPWrapper(xml, "urn:hl7-org:v3:PRPA_IN201301UV02", "http://172.18.2.91:8083/PixService.svc");
        logger.info("PIX服务返回信息" + soapWrapperPix);
        SaopFormat saopFormat = new SaopFormat();
        String xmlPhoto = saopFormat.PhotoMtom(map);
        logger.info("信息注册---Pho服务-----");
        Map<String, Object> soapWrapperPho = SharePlatformIDUtil.getSOAPWrapperXop(xmlPhoto, "urn:ihe:iti:2007:ProvideAndRegisterDocumentSet-b", "http://172.18.2.91:8086/DocRepositoryService.svc");
        logger.info("Pho服务返回信息" + soapWrapperPho);
      }  
  }
}
